/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.48 Revision 1.119
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.48 2009/10/16 15:02:15 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.119 2012/02/28 18:19:29 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
14MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
17IUSE="${IUSE} debug pch" 21IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
29fi
30
31DEPEND="dev-util/pkgconfig"
18RDEPEND=" 32RDEPEND="
19 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
23 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
25 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
45 !<x11-libs/qt-multimedia-${PV}
46 !>x11-libs/qt-multimedia-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-openvg-${PV}
50 !>x11-libs/qt-openvg-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV} 51 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999 52 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV} 53 !<x11-libs/qt-qt3support-${PV}
34 !>x11-libs/qt-qt3support-${PV}-r9999 54 !>x11-libs/qt-qt3support-${PV}-r9999
35 !<x11-libs/qt-script-${PV} 55 !<x11-libs/qt-script-${PV}
43 !<x11-libs/qt-webkit-${PV} 63 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999 64 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV} 65 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999 66 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47" 67"
48case "${PV}" in
49 4.?.?_rc* | 4.?.?_beta* )
50 SRCTYPE="${SRCTYPE:-opensource-src}"
51 MY_PV="${PV/_/-}"
52 ;;
53 *)
54 SRCTYPE="${SRCTYPE:-opensource-src}"
55 MY_PV="${PV}"
56 ;;
57esac
58 68
59if version_is_at_least 4.5.99999999 ${PV} ; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}"
61else
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi
64S=${WORKDIR}/${MY_P} 69S=${WORKDIR}/${MY_P}
65 70
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 71# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 72# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 73# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 74qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 75 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
87 if [[ $EAPI != 2 ]]; then 76
88 # Make sure debug setting corresponds with qt-core (bug 258512) 77 # Protect users by not allowing downgrades between releases
89 if [[ $PN != "qt-core" ]]; then 78 # Downgrading revisions within the same release should be allowed
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 79 if has_version '>'${CATEGORY}/${P}-r9999; then
91 ~x11-libs/qt-core-${PV} debug" 80 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
81 eerror "Sanity check to keep you from breaking your system:"
82 eerror " Downgrading Qt is completely unsupported and will break your system!"
83 die "aborting to save your system"
84 else
85 ewarn "Downgrading Qt is completely unsupported and will break your system!"
92 fi 86 fi
87 fi
93 88
94 # Check USE requirements 89 if [[ ${PN} == "qt-webkit" ]]; then
95 qt4-build_check_use 90 eshopts_push -s extglob
91 if is-flagq '-g?(gdb)?([1-9])'; then
92 echo
93 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
94 ewarn "You may experience really long compilation times and/or increased memory usage."
95 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
96 ewarn "For more info check out bug #307861"
97 echo
96 fi 98 fi
99 eshopts_pop
100 fi
97 101
98 PATH="${S}/bin:${PATH}" 102 PATH="${S}/bin${PATH:+:}${PATH}"
103 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 104 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
105 else
106 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
107 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
108 # platform detection. Note: needs to come before any directories to
109 # avoid extract failure.
110 [[ ${CHOST} == *-apple-darwin* ]] && \
111 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
112 ${QT4_EXTRACT_DIRECTORIES}"
113 fi
100 114
115 # Make sure ebuilds use the required EAPI
116 if [[ ${EAPI} != [234] ]]; then
117 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
118 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
119 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
120 die "qt4-build eclass requires EAPI 2,3 or 4"
121 fi
122
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 123 if ! version_is_at_least 4.1 $(gcc-version); then
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 124 ewarn "Using a GCC version lower than 4.1 is not supported!"
103 echo
104 ebeep 3
105 fi 125 fi
106} 126}
107 127
108# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 128# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
109# @DESCRIPTION: 129# @DESCRIPTION:
110# Arguments for build_target_directories. Takes the directories, in which the 130# Arguments for build_target_directories. Takes the directories in which the
111# code should be compiled. This is a space-separated list 131# code should be compiled. This is a space-separated list.
112 132
113# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 133# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
114# @DESCRIPTION: 134# @DESCRIPTION:
115# Space separated list including the directories that will be extracted from Qt 135# Space-separated list including the directories that will be extracted from
116# tarball 136# Qt tarball.
117 137
118# @FUNCTION: qt4-build_src_unpack 138# @FUNCTION: qt4-build_src_unpack
119# @DESCRIPTION: 139# @DESCRIPTION:
120# Unpacks the sources 140# Unpacks the sources.
121qt4-build_src_unpack() { 141qt4-build_src_unpack() {
122 setqtenv 142 setqtenv
123 local target targets licenses tar_pkg tar_args 143
124 if version_is_at_least 4.5 ${PV} ; then 144 local tarball="${MY_P}.tar.gz" target= targets=
125 licenses="LICENSE.GPL3 LICENSE.LGPL" 145 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
126 else
127 licenses="LICENSE.GPL2 LICENSE.GPL3"
128 fi
129 for target in configure ${licenses} projects.pro \
130 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 146 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
131 ${QT4_EXTRACT_DIRECTORIES}; do 147 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
148 do
132 targets="${targets} ${MY_P}/${target}" 149 targets+="${MY_P}/${target} "
133 done 150 done
134 151
135 tar_pkg=${MY_P}.tar.bz2 152 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
136 tar_args="xjpf" 153 tar -xzf "${DISTDIR}/${tarball}" ${targets}
137 if version_is_at_least 4.5.3 ${PV} ; then 154 eend $? || die "failed to unpack"
138 tar_pkg=${tar_pkg/bz2/gz}
139 tar_args="xzpf"
140 fi
141
142 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
143 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
144
145 case "${PV}" in
146 4.4.?)
147 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
148 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
149 ;;
150 esac
151
152 # Be backwards compatible for now
153 if [[ $EAPI != 2 ]]; then
154 qt4-build_src_prepare
155 fi
156} 155}
157 156
158# @ECLASS-VARIABLE: PATCHES 157# @ECLASS-VARIABLE: PATCHES
158# @DEFAULT_UNSET
159# @DESCRIPTION: 159# @DESCRIPTION:
160# In case you have patches to apply, specify them in PATCHES variable. Make sure 160# PATCHES array variable containing all various patches to be applied.
161# to specify the full path. This variable is necessary for src_prepare phase. 161# This variable is expected to be defined in global scope of ebuild.
162# example: 162# Make sure to specify the full path. This variable is utilised in
163# PATCHES="${FILESDIR}"/mypatch.patch 163# src_unpack/src_prepare phase, based on EAPI.
164# ${FILESDIR}"/mypatch2.patch"
165# 164#
165# @CODE
166# PATCHES=( "${FILESDIR}/mypatch.patch"
167# "${FILESDIR}/patches_folder/" )
168# @CODE
166 169
167# @FUNCTION: qt4-build_src_prepare 170# @FUNCTION: qt4-build_src_prepare
168# @DESCRIPTION: 171# @DESCRIPTION:
169# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 172# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
170# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 173# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
171qt4-build_src_prepare() { 174qt4-build_src_prepare() {
172 setqtenv 175 setqtenv
173 cd "${S}" 176 cd "${S}"
174 177
178 if version_is_at_least "4.7"; then
179 # fix libX11 dependency on non X packages
180 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
181 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
182
183 qt_assistant_cleanup
184 fi
185
186 if use aqua; then
187 # provide a proper macx-g++-64
188 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
189
190 sed -e '/^CONFIG/s:app_bundle::' \
191 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
192 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
193 fi
194
175 if [[ ${PN} != qt-core ]]; then 195 if [[ ${PN} != qt-core ]]; then
176 skip_qmake_build_patch 196 skip_qmake_build
177 skip_project_generation_patch 197 skip_project_generation
178 symlink_binaries_to_buildtree 198 symlink_binaries_to_buildtree
179 fi 199 fi
180 200
201 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
202 # qmake bus errors with -O2 but -O3 works
203 replace-flags -O2 -O3
204 fi
205
181 # Bug 178652 206 # Bug 178652
182 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 207 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
183 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 208 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
184 append-flags -fno-gcse 209 append-flags -fno-gcse
185 fi 210 fi
186 211
212 if use_if_iuse c++0x; then
213 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
214 ewarn "this is an official standard, some of the reverse dependencies"
215 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
216 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
217 ewarn "disabled."
218 append-flags -std=c++0x
219 fi
220
187 # Unsupported old gcc versions - hardened needs this :( 221 # Unsupported old gcc versions - hardened needs this :(
188 if [[ $(gcc-major-version) -lt "4" ]] ; then 222 if [[ $(gcc-major-version) -lt 4 ]] ; then
189 ewarn "Appending -fno-stack-protector to CXXFLAGS" 223 ewarn "Appending -fno-stack-protector to CXXFLAGS"
190 append-cxxflags -fno-stack-protector 224 append-cxxflags -fno-stack-protector
191 # Bug 253127 225 # Bug 253127
192 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 226 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
193 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 227 -i mkspecs/common/g++.conf || die
194 fi 228 fi
229
230 # Bug 261632
231 if use ppc64; then
232 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
233 append-flags -mminimal-toc
234 fi
235
236 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
237 sed -e "/^SYSTEM_VARIABLES=/i \
238 CC='$(tc-getCC)'\n\
239 CXX='$(tc-getCXX)'\n\
240 CFLAGS='${CFLAGS}'\n\
241 CXXFLAGS='${CXXFLAGS}'\n\
242 LDFLAGS='${LDFLAGS}'\n" \
243 -i configure \
244 || die "sed SYSTEM_VARIABLES failed"
245
246 # Respect CC, CXX, LINK and *FLAGS in config.tests
247 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
248 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
249 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
250 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
251 || die "sed config.tests failed"
252
253 # Strip predefined CFLAGS from mkspecs (bug 312689)
254 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
195 255
196 # Bug 172219 256 # Bug 172219
257 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
258
259 if [[ ${CHOST} == *-darwin* ]]; then
260 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
261 # crippled (by design) :/
262 sed \
197 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 263 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
198 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 264 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
199 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 265 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
200 -e "s:X11R6/::" \ 266 -e "s:-arch\s\w*::g" \
201 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 267 -i mkspecs/common/mac-g++.conf \
268 || die "sed mkspecs/common/mac-g++.conf failed"
202 269
203 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 270 # Fix configure's -arch settings that appear in qmake/Makefile and also
204 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 271 # fix arch handling (automagically duplicates our -arch arg and breaks
205 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 272 # pch). Additionally disable Xarch support.
206 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 273 sed \
274 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf \
284 || die "sed -arch/-Xarch failed"
285
286 # On Snow Leopard don't fall back to 10.5 deployment target.
287 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
290 -i configure mkspecs/common/mac-g++.conf \
291 || die "sed deployment target failed"
292 fi
293 fi
294
295 # this one is needed for all systems with a separate -liconv, apart from
296 # Darwin, for which the sources already cater for -liconv
297 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
298 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
299 -i config.tests/unix/iconv/iconv.pro \
300 || die "sed iconv.pro failed"
301 fi
302
303 # we need some patches for Solaris
304 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
207 311
208 base_src_prepare 312 base_src_prepare
209} 313}
210 314
211# @FUNCTION: qt4-build_src_configure 315# @FUNCTION: qt4-build_src_configure
213# Default configure phase 317# Default configure phase
214qt4-build_src_configure() { 318qt4-build_src_configure() {
215 setqtenv 319 setqtenv
216 myconf="$(standard_configure_options) ${myconf}" 320 myconf="$(standard_configure_options) ${myconf}"
217 321
322 # this one is needed for all systems with a separate -liconv, apart from
323 # Darwin, for which the sources already cater for -liconv
324 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
325 myconf+=" -liconv"
326
327 if use_if_iuse glib; then
328 # use -I, -L and -l from configure
329 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
330 # avoid the -pthread argument
331 myconf+=" ${glibflags//-pthread}"
332 unset glibflags
333 fi
334
335 if use_if_iuse qpa; then
336 ewarn
337 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
338 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
339 ewarn "disable it before reporting any bugs related to this useflag."
340 ewarn
341 myconf+=" -qpa"
342 fi
343
344 if use aqua ; then
345 # On (snow) leopard use the new (frameworked) cocoa code.
346 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
347 myconf+=" -cocoa -framework"
348
349 # We are crazy and build cocoa + qt3support :-)
350 if use qt3support; then
351 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
352 -i configure || die
353 fi
354
355 # We need the source's headers, not the installed ones.
356 myconf+=" -I${S}/include"
357
358 # Add hint for the framework location.
359 myconf+=" -F${QTLIBDIR}"
360 fi
361 else
362 # freetype2 include dir is non-standard, thus include it on configure
363 # use -I from configure
364 myconf+=" $(pkg-config --cflags freetype2)"
365 fi
366
218 echo ./configure ${myconf} 367 echo ./configure ${myconf}
219 ./configure ${myconf} || die "./configure failed" 368 ./configure ${myconf} || die "./configure failed"
220 myconf="" 369 myconf=""
370
371 prepare_directories ${QT4_TARGET_DIRECTORIES}
221} 372}
222 373
223# @FUNCTION: qt4-build_src_compile 374# @FUNCTION: qt4-build_src_compile
375# @DESCRIPTION:
224# @DESCRIPTION: Actual compile phase 376# Actual compile phase
225qt4-build_src_compile() { 377qt4-build_src_compile() {
226 setqtenv 378 setqtenv
227 # Be backwards compatible for now
228 if [[ $EAPI != 2 ]]; then
229 qt4-build_src_configure
230 fi
231 379
232 build_directories "${QT4_TARGET_DIRECTORIES}" 380 build_directories ${QT4_TARGET_DIRECTORIES}
381}
382
383# @FUNCTION: qt4-build_src_test
384# @DESCRIPTION:
385# Runs tests only in target directories.
386qt4-build_src_test() {
387 # QtMultimedia does not have any test suite (bug #332299)
388 [[ ${PN} == "qt-multimedia" ]] && return
389
390 for dir in ${QT4_TARGET_DIRECTORIES}; do
391 emake -j1 check -C ${dir}
392 done
393}
394
395# @FUNCTION: fix_includes
396# @DESCRIPTION:
397# For MacOS X we need to add some symlinks when frameworks are
398# being used, to avoid complications with some more or less stupid packages.
399fix_includes() {
400 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
401 # Some packages tend to include <Qt/...>
402 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
403
404 # Fake normal headers when frameworks are installed... eases life later on
405 local dest f h
406 for frw in "${D}${QTLIBDIR}"/*.framework; do
407 [[ -e "${frw}"/Headers ]] || continue
408 f=$(basename ${frw})
409 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
411
412 # Link normal headers as well.
413 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
414 h=$(basename ${hdr})
415 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
416 done
417 done
418 fi
233} 419}
234 420
235# @FUNCTION: qt4-build_src_install 421# @FUNCTION: qt4-build_src_install
236# @DESCRIPTION: 422# @DESCRIPTION:
237# Perform the actual installation including some library fixes. 423# Perform the actual installation including some library fixes.
238qt4-build_src_install() { 424qt4-build_src_install() {
425 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
239 setqtenv 426 setqtenv
427
240 install_directories "${QT4_TARGET_DIRECTORIES}" 428 install_directories ${QT4_TARGET_DIRECTORIES}
241 install_qconfigs 429 install_qconfigs
242 fix_library_files 430 fix_library_files
431 fix_includes
432
433 # remove .la files since we are building only shared Qt libraries
434 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
243} 435}
244 436
245# @FUNCTION: setqtenv 437# @FUNCTION: setqtenv
438# @INTERNAL
246setqtenv() { 439setqtenv() {
247 # Set up installation directories 440 # Set up installation directories
248 QTBASEDIR=/usr/$(get_libdir)/qt4
249 QTPREFIXDIR=/usr 441 QTPREFIXDIR=${EPREFIX}/usr
250 QTBINDIR=/usr/bin 442 QTBINDIR=${EPREFIX}/usr/bin
251 QTLIBDIR=/usr/$(get_libdir)/qt4 443 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
252 QMAKE_LIBDIR_QT=${QTLIBDIR}
253 QTPCDIR=/usr/$(get_libdir)/pkgconfig 444 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
254 QTDATADIR=/usr/share/qt4
255 QTDOCDIR=/usr/share/doc/qt-${PV} 445 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
256 QTHEADERDIR=/usr/include/qt4 446 QTHEADERDIR=${EPREFIX}/usr/include/qt4
257 QTPLUGINDIR=${QTLIBDIR}/plugins 447 QTPLUGINDIR=${QTLIBDIR}/plugins
258 QTSYSCONFDIR=/etc/qt4 448 QTIMPORTDIR=${QTLIBDIR}/imports
449 QTDATADIR=${EPREFIX}/usr/share/qt4
259 QTTRANSDIR=${QTDATADIR}/translations 450 QTTRANSDIR=${QTDATADIR}/translations
451 QTSYSCONFDIR=${EPREFIX}/etc/qt4
260 QTEXAMPLESDIR=${QTDATADIR}/examples 452 QTEXAMPLESDIR=${QTDATADIR}/examples
261 QTDEMOSDIR=${QTDATADIR}/demos 453 QTDEMOSDIR=${QTDATADIR}/demos
454 QMAKE_LIBDIR_QT=${QTLIBDIR}
262 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4 455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
456
263 PLATFORM=$(qt_mkspecs_dir) 457 PLATFORM=$(qt_mkspecs_dir)
264 458
265 unset QMAKESPEC 459 unset QMAKESPEC
266} 460}
267 461
268# @FUNCTION: standard_configure_options 462# @FUNCTION: standard_configure_options
463# @INTERNAL
269# @DESCRIPTION: 464# @DESCRIPTION:
270# Sets up some standard configure options, like libdir (if necessary), whether 465# Sets up some standard configure options, like libdir (if necessary), whether
271# debug info is wanted or not. 466# debug info is wanted or not.
272standard_configure_options() { 467standard_configure_options() {
273 local myconf="" 468 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
469 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
470 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
471 -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR} -sysconfdir ${QTSYSCONFDIR}
472 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
473 -opensource -confirm-license -shared -fast -largefile -stl -verbose
474 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
274 475
275 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 476 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
276 477
277 # Disable visibility explicitly if gcc version isn't 4 478 # debug/release
278 if [[ "$(gcc-major-version)" -lt "4" ]]; then
279 myconf="${myconf} -no-reduce-exports"
280 fi
281
282 # precompiled headers doesn't work on hardened, where the flag is masked.
283 if use pch; then 479 if use debug; then
284 myconf="${myconf} -pch" 480 myconf+=" -debug"
285 else 481 else
286 myconf="${myconf} -no-pch" 482 myconf+=" -release"
287 fi 483 fi
288
289 if use debug; then
290 myconf="${myconf} -debug -no-separate-debug-info" 484 myconf+=" -no-separate-debug-info"
291 else 485
292 myconf="${myconf} -release -no-separate-debug-info" 486 # exceptions USE flag
293 fi 487 local exceptions="-exceptions"
488 in_iuse exceptions && exceptions="$(qt_use exceptions)"
489 myconf+=" ${exceptions}"
490
491 # disable RPATH on Qt >= 4.8 (bug 380415)
492 version_is_at_least 4.8 && myconf+=" -no-rpath"
493
494 # precompiled headers don't work on hardened, where the flag is masked
495 myconf+=" $(qt_use pch)"
496
497 # -reduce-relocations
498 # This flag seems to introduce major breakage to applications,
499 # mostly to be seen as a core dump with the message "QPixmap: Must
500 # construct a QApplication before a QPaintDevice" on Solaris.
501 # -- Daniel Vergien
502 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
503
504 use aqua && myconf+=" -no-framework"
294 505
295 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 506 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
296 # $(tc-arch). Therefore we convert it to supported values. 507 # $(tc-arch). Therefore we convert it to supported values.
297 case "$(tc-arch)" in 508 case "$(tc-arch)" in
298 amd64) myconf="${myconf} -arch x86_64" ;; 509 amd64|x64-*) myconf+=" -arch x86_64" ;;
510 ppc-macos) myconf+=" -arch ppc" ;;
299 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 511 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
512 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
513 x86-macos) myconf+=" -arch x86" ;;
300 x86|x86-*) myconf="${myconf} -arch i386" ;; 514 x86|x86-*) myconf+=" -arch i386" ;;
301 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 515 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
302 hppa|sh) myconf="${myconf} -arch generic" ;; 516 hppa|sh) myconf+=" -arch generic" ;;
303 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 517 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
304 esac 518 esac
305 519
306 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
307 local exceptions=
308 case "${PV}" in
309 4.6.*)
310 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
311 exceptions="-no-exceptions"
312 fi
313 ;;
314 *)
315 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
316 ;;
317 esac
318
319 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath
320 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
321 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
322 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
323 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
324 -demosdir ${QTDEMOSDIR} -silent -fast
325 ${exceptions}
326 -reduce-relocations -nomake examples -nomake demos"
327
328 # Make eclass >= 4.5.x ready
329 case "${MY_PV}" in
330 4.5.* | 4.6.* )
331 myconf="${myconf} -opensource"
332 ;;
333 esac
334
335 echo "${myconf}" 520 echo "${myconf}"
336} 521}
522
523# @FUNCTION: prepare_directories
524# @USAGE: < directories >
525# @INTERNAL
526# @DESCRIPTION:
527# Generates Makefiles for the given list of directories.
528prepare_directories() {
529 for x in "$@"; do
530 pushd "${S}"/${x} >/dev/null || die
531 einfo "Running qmake in: ${x}"
532 # avoid running over the maximum argument number, bug #299810
533 {
534 echo "${S}"/mkspecs/common/*.conf
535 find "${S}" -name '*.pr[io]'
536 } | xargs sed -i \
537 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
538 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
539 || die
540 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
541 popd >/dev/null || die
542 done
543}
544
337 545
338# @FUNCTION: build_directories 546# @FUNCTION: build_directories
339# @USAGE: < directories > 547# @USAGE: < directories >
548# @INTERNAL
340# @DESCRIPTION: 549# @DESCRIPTION:
341# Compiles the code in $QT4_TARGET_DIRECTORIES 550# Compiles the code in the given list of directories.
342build_directories() { 551build_directories() {
343 local dirs="$@"
344 for x in ${dirs}; do 552 for x in "$@"; do
345 cd "${S}"/${x} 553 pushd "${S}"/${x} >/dev/null || die
346 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 554 emake CC="$(tc-getCC)" \
347 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 555 CXX="$(tc-getCXX)" \
348 emake CC="@echo compiling \$< && $(tc-getCC)" \
349 CXX="@echo compiling \$< && $(tc-getCXX)" \
350 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 556 LINK="$(tc-getCXX)" || die "emake failed"
557 popd >/dev/null || die
351 done 558 done
352} 559}
353 560
354# @FUNCTION: install_directories 561# @FUNCTION: install_directories
355# @USAGE: < directories > 562# @USAGE: < directories >
563# @INTERNAL
356# @DESCRIPTION: 564# @DESCRIPTION:
357# run emake install in the given directories, which are separated by spaces 565# Runs emake install in the given directories, which are separated by spaces.
358install_directories() { 566install_directories() {
359 local dirs="$@"
360 for x in ${dirs}; do 567 for x in "$@"; do
361 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 568 pushd "${S}"/${x} >/dev/null || die
362 emake INSTALL_ROOT="${D}" install || die "emake install failed" 569 emake INSTALL_ROOT="${D}" install || die "emake install failed"
363 popd >/dev/null || die "Can't popd from ${S}/${x}" 570 popd >/dev/null || die
364 done 571 done
365} 572}
366 573
367# @ECLASS-VARIABLE: QCONFIG_ADD 574# @ECLASS-VARIABLE: QCONFIG_ADD
368# @DESCRIPTION: 575# @DESCRIPTION:
369# List options that need to be added to QT_CONFIG in qconfig.pri 576# List options that need to be added to QT_CONFIG in qconfig.pri
370QCONFIG_ADD="${QCONFIG_ADD:-}" 577: ${QCONFIG_ADD:=}
371 578
372# @ECLASS-VARIABLE: QCONFIG_REMOVE 579# @ECLASS-VARIABLE: QCONFIG_REMOVE
373# @DESCRIPTION: 580# @DESCRIPTION:
374# List options that need to be removed from QT_CONFIG in qconfig.pri 581# List options that need to be removed from QT_CONFIG in qconfig.pri
375QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 582: ${QCONFIG_REMOVE:=}
376 583
377# @ECLASS-VARIABLE: QCONFIG_DEFINE 584# @ECLASS-VARIABLE: QCONFIG_DEFINE
378# @DESCRIPTION: 585# @DESCRIPTION:
379# List variables that should be defined at the top of QtCore/qconfig.h 586# List variables that should be defined at the top of QtCore/qconfig.h
380QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 587: ${QCONFIG_DEFINE:=}
381 588
382# @FUNCTION: install_qconfigs 589# @FUNCTION: install_qconfigs
590# @INTERNAL
591# @DESCRIPTION:
383# @DESCRIPTION: Install gentoo-specific mkspecs configurations 592# Install gentoo-specific mkspecs configurations.
384install_qconfigs() { 593install_qconfigs() {
385 local x 594 local x
386 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 595 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
387 for x in QCONFIG_ADD QCONFIG_REMOVE; do 596 for x in QCONFIG_ADD QCONFIG_REMOVE; do
388 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 597 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
389 done 598 done
390 insinto ${QTDATADIR}/mkspecs/gentoo 599 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
391 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 600 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
392 fi 601 fi
393 602
394 if [[ -n ${QCONFIG_DEFINE} ]]; then 603 if [[ -n ${QCONFIG_DEFINE} ]]; then
395 for x in ${QCONFIG_DEFINE}; do 604 for x in ${QCONFIG_DEFINE}; do
396 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 605 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
397 done 606 done
398 insinto ${QTHEADERDIR}/Gentoo 607 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
399 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 608 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
400 fi 609 fi
401} 610}
402 611
403# @FUNCTION: generate_qconfigs 612# @FUNCTION: generate_qconfigs
404# @DESCRIPTION: Generates gentoo-specific configurations 613# @INTERNAL
614# @DESCRIPTION:
615# Generates gentoo-specific qconfig.{h,pri}.
405generate_qconfigs() { 616generate_qconfigs() {
406 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 617 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
407 local x qconfig_add qconfig_remove qconfig_new 618 local x qconfig_add qconfig_remove qconfig_new
408 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 619 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
409 [[ -f ${x} ]] || continue 620 [[ -f ${x} ]] || continue
410 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 621 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
411 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 622 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
412 done 623 done
413 624
414 # these error checks do not use die because dying in pkg_post{inst,rm} 625 # these error checks do not use die because dying in pkg_post{inst,rm}
415 # just makes things worse. 626 # just makes things worse.
416 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 627 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
423 634
424 # generate list of QT_CONFIG entries from the existing list 635 # generate list of QT_CONFIG entries from the existing list
425 # including qconfig_add and excluding qconfig_remove 636 # including qconfig_add and excluding qconfig_remove
426 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 637 for x in $(sed -n 's/^QT_CONFIG +=//p' \
427 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 638 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
428 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 639 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
429 done 640 done
430 641
431 # replace the existing QT_CONFIG list with qconfig_new 642 # replace the existing QT_CONFIG list with qconfig_new
432 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 643 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
433 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 644 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
457 fi 668 fi
458 fi 669 fi
459} 670}
460 671
461# @FUNCTION: qt4-build_pkg_postrm 672# @FUNCTION: qt4-build_pkg_postrm
673# @DESCRIPTION:
462# @DESCRIPTION: Generate configurations when the package is completely removed 674# Regenerate configuration when the package is completely removed.
463qt4-build_pkg_postrm() { 675qt4-build_pkg_postrm() {
464 generate_qconfigs 676 generate_qconfigs
465} 677}
466 678
467# @FUNCTION: qt4-build_pkg_postinst 679# @FUNCTION: qt4-build_pkg_postinst
680# @DESCRIPTION:
468# @DESCRIPTION: Generate configuration, plus throws a message about possible 681# Regenerate configuration, plus throw a message about possible
469# breakages and proposed solutions. 682# breakages and proposed solutions.
470qt4-build_pkg_postinst() { 683qt4-build_pkg_postinst() {
471 generate_qconfigs 684 generate_qconfigs
472 echo
473 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
474 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
475 ewarn "should recompile the packages providing these plugins. Also, make sure you"
476 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
477 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
478 ewarn
479 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
480 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
481 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
482 ewarn "configuration."
483 ewarn
484 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
485 echo
486} 685}
487 686
488# @FUNCTION: skip_qmake_build_patch 687# @FUNCTION: skip_qmake_build
688# @INTERNAL
489# @DESCRIPTION: 689# @DESCRIPTION:
490# Don't need to build qmake, as it's already installed from qt-core 690# Patches configure to skip qmake compilation, as it's already installed by qt-core.
491skip_qmake_build_patch() { 691skip_qmake_build() {
492 # Don't need to build qmake, as it's already installed from qt-core
493 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 692 sed -i -e "s:if true:if false:g" "${S}"/configure || die
494} 693}
495 694
496# @FUNCTION: skip_project_generation_patch 695# @FUNCTION: skip_project_generation
696# @INTERNAL
497# @DESCRIPTION: 697# @DESCRIPTION:
498# Exit the script early by throwing in an exit before all of the .pro files are scanned 698# Exit the script early by throwing in an exit before all of the .pro files are scanned.
499skip_project_generation_patch() { 699skip_project_generation() {
500 # Exit the script early by throwing in an exit before all of the .pro files are scanned
501 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 700 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
502 -i "${S}"/configure || die "Sed failed"
503} 701}
504 702
505# @FUNCTION: symlink_binaries_to_buildtree 703# @FUNCTION: symlink_binaries_to_buildtree
704# @INTERNAL
506# @DESCRIPTION: 705# @DESCRIPTION:
507# Symlink generated binaries to buildtree so they can be used during compilation 706# Symlinks generated binaries to buildtree, so they can be used during compilation time.
508# time
509symlink_binaries_to_buildtree() { 707symlink_binaries_to_buildtree() {
510 for bin in qmake moc uic rcc; do 708 for bin in qmake moc uic rcc; do
511 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 709 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
512 done 710 done
513} 711}
514 712
515# @FUNCTION: fix_library_files 713# @FUNCTION: fix_library_files
714# @INTERNAL
516# @DESCRIPTION: 715# @DESCRIPTION:
517# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 716# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
518# moves the *.pc-files into the pkgconfig directory 717# moves the *.pc files into the pkgconfig directory.
519fix_library_files() { 718fix_library_files() {
719 local libfile
520 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 720 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
521 if [[ -e ${libfile} ]]; then 721 if [[ -e ${libfile} ]]; then
522 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 722 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
523 fi 723 fi
524 done 724 done
525 725
526 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 726 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
527 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 727 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
528 if [[ -e ${libfile} ]]; then 728 if [[ -e ${libfile} ]]; then
529 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 729 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
530 730
531 # Move .pc files into the pkgconfig directory 731 # Move .pc files into the pkgconfig directory
532 dodir ${QTPCDIR} 732 dodir ${QTPCDIR#${EPREFIX}}
533 mv ${libfile} "${D}"/${QTPCDIR}/ \ 733 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
534 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
535 fi 734 fi
536 done 735 done
537 736
538 # Don't install an empty directory 737 # Don't install an empty directory
539 rmdir "${D}"/${QTLIBDIR}/pkgconfig 738 rmdir "${D}"/${QTLIBDIR}/pkgconfig
540} 739}
541 740
542# @FUNCTION: qt_use 741# @FUNCTION: qt_use
543# @USAGE: < flag > [ feature ] [ enableval ] 742# @USAGE: < flag > [ feature ] [ enableval ]
544# @DESCRIPTION: 743# @DESCRIPTION:
545# This will echo "${enableval}-${feature}" if <flag> is enabled, or 744# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
546# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 745# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
547# will be used for that. If [enableval] is not specified, it omits the 746# will be used for that. If [enableval] is not specified, it omits the
548# assignment-part 747# "-${enableval}" part.
549qt_use() { 748qt_use() {
550 local flag="${1}" 749 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
551 local feature="${1}"
552 local enableval=
553
554 [[ -n ${2} ]] && feature=${2}
555 [[ -n ${3} ]] && enableval="-${3}"
556
557 if use ${flag}; then
558 echo "${enableval}-${feature}"
559 else
560 echo "-no-${feature}"
561 fi
562}
563
564# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
565# @DESCRIPTION:
566# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
567# (eutils.eclass), line per line.
568#
569# Example:
570# @CODE
571# pkg_setup() {
572# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
573# ~x11-libs/qt-gui-${PV} qt3support"
574# qt4-build_check_use
575# }
576# @CODE
577
578# Run built_with_use on each flag and print appropriate error messages if any
579# flags are missing
580
581_qt_built_with_use() {
582 local missing opt pkg flag flags
583
584 if [[ ${1} = "--missing" ]]; then
585 missing="${1} ${2}" && shift 2
586 fi
587 if [[ ${1:0:1} = "-" ]]; then
588 opt=${1} && shift
589 fi
590
591 pkg=${1} && shift
592
593 for flag in "${@}"; do
594 flags="${flags} ${flag}"
595 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
596 flags="${flags}*"
597 else
598 [[ ${opt} = "-o" ]] && return 0
599 fi
600 done
601 if [[ "${flags# }" = "${@}" ]]; then
602 return 0
603 fi
604 if [[ ${opt} = "-o" ]]; then
605 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
606 else
607 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
608 fi
609 return 1
610}
611
612# @FUNCTION: qt4-build_check_use
613# @DESCRIPTION:
614# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
615# USE flags listed.
616#
617# If any of the required USE flags are missing, an eerror will be printed for
618# each package with missing USE flags.
619qt4-build_check_use() {
620 local line missing
621 while read line; do
622 [[ -z ${line} ]] && continue
623 if ! _qt_built_with_use ${line}; then
624 missing=true
625 fi
626 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
627 if [[ -n ${missing} ]]; then
628 echo
629 eerror "Flags marked with an * are missing."
630 die "Missing USE flags found"
631 fi
632} 750}
633 751
634# @FUNCTION: qt_mkspecs_dir 752# @FUNCTION: qt_mkspecs_dir
635# @RETURN: the specs-directory w/o path 753# @RETURN: the specs-directory w/o path
636# @DESCRIPTION: 754# @DESCRIPTION:
637# Allows us to define which mkspecs dir we want to use. 755# Allows us to define which mkspecs dir we want to use.
638qt_mkspecs_dir() { 756qt_mkspecs_dir() {
639 # Allows us to define which mkspecs dir we want to use.
640 local spec 757 local spec=
641
642 case ${CHOST} in 758 case ${CHOST} in
643 *-freebsd*|*-dragonfly*) 759 *-freebsd*|*-dragonfly*)
644 spec="freebsd" ;; 760 spec=freebsd ;;
645 *-openbsd*) 761 *-openbsd*)
646 spec="openbsd" ;; 762 spec=openbsd ;;
647 *-netbsd*) 763 *-netbsd*)
648 spec="netbsd" ;; 764 spec=netbsd ;;
649 *-darwin*) 765 *-darwin*)
766 if use aqua; then
767 # mac with carbon/cocoa
768 spec=macx
769 else
770 # darwin/mac with x11
650 spec="darwin" ;; 771 spec=darwin
772 fi
773 ;;
774 *-solaris*)
775 spec=solaris ;;
651 *-linux-*|*-linux) 776 *-linux-*|*-linux)
652 spec="linux" ;; 777 spec=linux ;;
653 *) 778 *)
654 die "Unknown CHOST, no platform choosen." 779 die "Unknown CHOST, no platform chosen"
655 esac 780 esac
656 781
657 CXX=$(tc-getCXX) 782 CXX=$(tc-getCXX)
658 if [[ ${CXX/g++/} != ${CXX} ]]; then 783 if [[ ${CXX} == *g++* ]]; then
659 spec="${spec}-g++" 784 spec+=-g++
660 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 785 elif [[ ${CXX} == *icpc* ]]; then
661 spec="${spec}-icc" 786 spec+=-icc
662 else 787 else
663 die "Unknown compiler ${CXX}." 788 die "Unknown compiler '${CXX}'"
664 fi 789 fi
665 if [[ -n "${LIBDIR/lib}" ]]; then 790
666 spec="${spec}-${LIBDIR/lib}" 791 # Add -64 for 64bit profiles
792 if use x64-freebsd ||
793 use amd64-linux ||
794 use x64-macos ||
795 use x64-solaris ||
796 use sparc64-solaris
797 then
798 spec+=-64
667 fi 799 fi
668 800
669 echo "${spec}" 801 echo "${spec}"
670} 802}
671 803
672case ${EAPI:-0} in 804# @FUNCTION: qt_assistant_cleanup
673 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 805# @INTERNAL
806# @DESCRIPTION:
807# Tries to clean up tools.pro for qt-assistant ebuilds.
808# Meant to be called in src_prepare().
809# Since Qt 4.7.4 this function is a no-op.
810qt_assistant_cleanup() {
811 # apply patching to qt-assistant ebuilds only
812 [[ ${PN} != "qt-assistant" ]] && return
813
814 # no longer needed for 4.7.4 and later
815 version_is_at_least "4.7.4" && return
816
817 # different versions (and branches...) may need different handling,
818 # add a case if you need special handling
819 case "${MY_PV_EXTRA}" in
820 *kde-qt*)
821 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
822 -e "/mac/,/^embedded.*makeqpf$/d" \
823 -i tools/tools.pro || die "patching tools.pro failed"
824 ;;
825 *)
826 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
827 -e "/mac/,/^embedded.*makeqpf$/d" \
828 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
829 -i tools/tools.pro || die "patching tools.pro failed"
830 ;;
831 esac
832}
833
834# @FUNCTION: qt_nolibx11
835# @INTERNAL
836# @DESCRIPTION:
837# Ignore X11 tests for packages that don't need X libraries installed.
838qt_nolibx11() {
839 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
840 die "x11 check sed failed"
841}
842
674 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 843EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
675esac

Legend:
Removed from v.1.48  
changed lines
  Added in v.1.119

  ViewVC Help
Powered by ViewVC 1.1.20